import java.util.Date;

public abstract class AbstractLogger implements Logger {
	private int curlevel=LOG_NORMAL;

	private static String lev_rep[]={"CRITICAL", //Indexed by actual numbers!
					 "   ERROR",
					 "    WARN",
					 "  NORMAL",
					 "    INFO",
					 "   DEBUG"};


	public void setLogLevel(int curlevel) {
		this.curlevel=curlevel;
	}

	public void logMessage(int level, String message) {
		if(level<=curlevel) {
			String formattedmessage="["+new Date().toString()+"] "+lev_rep[level]+" Thread:"+Thread.currentThread().getName()+" "+message;
		
			logMessageImpl(formattedmessage);	
		}
	}

	public void logMessage(String message) {
		logMessage(LOG_NORMAL, message);
	}

	/* Keep an actual underlying wrapper */ 
	public abstract void logMessageImpl(String formattedmessage);
}
